
int triac_pin = 3;  // Digital output to TRIAC
int dimm_time = 8000;  // 8000 = 20% output power
bool zero_cross = 0;
void setup(void) {
  Serial.begin(9600);
  Serial.println("Power on...");
  pinMode(triac_pin, OUTPUT);
  digitalWrite(triac_pin, HIGH);
  delay(2000);
  digitalWrite(triac_pin, LOW);
  Serial.println("Power off...");
  delay(2000);
  Serial.println("Start dimming...");
  attachInterrupt(0, zero_cross_detect, CHANGE);
}

void loop() {
  if (zero_cross) {
    if (dimm_time < 9500) {
      delayMicroseconds(dimm_time);
      digitalWrite(triac_pin, HIGH);
      delayMicroseconds(200);
      digitalWrite(triac_pin, LOW);
    }
    zero_cross = 0;
  }

  if (dimm_time > 8800) {
    dimm_time = 9500;
  }
  if (dimm_time < 1000) {
    dimm_time = 1000;
  }

  if (Serial.available() > 1) {
    int getval = 10000 - (Serial.parseInt() * 100);
    if (getval >= 0 && getval <= 10000) {
      dimm_time = getval;
      Serial.print("Dimm to ");
      Serial.print(100 - (getval / 100));
      Serial.println(" %");
    } else {
      Serial.println("Wrong value!");
    }
  }
}

void zero_cross_detect() {  // If zero crossing is detected
  zero_cross = 1;
}
